$('body, html').addClass('preload');

// Add jQuery for the page scripts
embedScript('lib/jquery.js');

// Retrieve Settings and Templates
var settings;
safari.self.tab.dispatchMessage('getSettings', true);
safari.self.addEventListener('message', getMessage, false);
function getMessage(message) {
	if (message.name === 'settings') {
		settings = message.message;
		for (i in settings.templates) {
			if (typeof settings.templates[i] == 'string') settings.templates[i] = settings.templates[i].replace(/&gt;/g, '>');
		}
		for (i in settings.templates.partials) {
			if (typeof settings.templates.partials[i] == 'string') settings.templates.partials[i] = settings.templates.partials[i].replace(/&gt;/g, '>');
		}
		load();
	}
}
var view;
// Load script
function load(){

var site = getSite();
prepend('body', 'header', site);

// ABI
if (site.abi) {
	// Replace ABI's CSS
	$('link[href*="cssABI"], link[href*="ABIDynamicMenus"]').remove();
	embedCSS('css/abi.css');

	var page = getPage();
	var oldPage = $('table:first');

	// ABI Root
	if (page.root) {
		window.location = 'parentabi';
	}
	// ABI Login
	else if (page.login) {	
		$('body > table').hide();

		// Add page scripts
		embedScript('page/login.js');
		
		// Build login form
		var message = '';
		if ( $('table table tbody tr [style*="#FFFF33"], table table tbody tr [color*="#FFFF33"]').length > 0 ) {
			settings.auto_login = false;
			message = $('table table tbody tr [style*="#FFFF33"], table table tbody tr [color*="#FFFF33"]').text();
		}
		console.log(settings.auto_login);
		before(oldPage, 'login', {
			auto_login: settings.auto_login,
			email: settings.email,
			password: settings.password,
			message: message
		});
	}
	// ABI Calendar
	else if (page.calendar) {
		before(oldPage, 'abi_nav', page);
		
		// Embed in-page scripts
		embedScript('lib/mustache.js'); 
		embedScript('page/calendar.js');
		
		view = getCalendarView();
		
		$('span:contains("Change")').click(); // Trigger loading of date picker...
		$('#overDiv').attr('hidden', 'true'); // ...and then hide it
				
		// Gather calendar
		var calendar = {};
		if (view.day) {
			var date = new Date($('tbody tbody tbody tbody tbody .HeaderRowBold td:contains("/")').text());
			
			calendar['date'] = date.strftime('%A, %B %e, %Y');
			calendar['events'] = [];
			
			// Iterate over events
			var events = $('tbody tbody tbody tbody > tr.NormalRowEven table[style*="border-color"]');
			$(events).each(function(i) {
				var event = $('td[align="left"]', events[i]);
				
				// Gather calendar data
				calendar.events[i] = {
					type: getEventType(event),
					body: getEventBody(event),
					details: getEventDetails(event),
					period: getEventPeriod(event),
					edit_js: getEditJS(event)
				}
			});
		} // End view.day
		if (view.week) {
			var days = $('tbody tbody tbody tbody > tr.NormalRowEven > td[align*="center"] > table > tbody');
			
			// Get date
			var month = $('tbody tbody tbody tbody > tr.HeaderRowBold > td[colspan*="6"]:not(:has(table))').text();
			var year = $('#overDiv tbody tbody center font:first font:first b').text().match(/\d{4}/)[0];
			var date = new Date($('b',days[0]).text()+' '+month+' '+year);
			var endDate = new Date($('b:last', days[days.length-1]).text()+' '+month+' '+year);
						
			calendar['date'] = date.strftime('%A, %B %e, %Y')+' &ndash; '+endDate.strftime('%A, %B %e, %Y');
			calendar['days'] = [];
			$(days).each(function(i) {
				var events = $('td[align="left"] td[align="left"] td[align="left"]', days[i]);
				calendar.days[i] = [];
				
//				$(events).each(function(j) {
					// Gather calendar data
//					calendar.days[i]['events'][j] = {
//						type: getEventType(events[j]),
//						body: getEventBody(events[j]),
//						details: getEventDetails(events[j]),
//						period: getEventPeriod(events[j]),
//						edit_js: getEditJS(events[j])
//					}
//				})
			});
		} // End view.week
		
		console.log('Calendar:',calendar);
		
		// Gather filters
		var filters = gatherFilters(date);
		console.log('Filters:', filters);
		
		// Build UI
		$(oldPage).before('<div id="wrap"></div>');
		
		append('#wrap', 'calendar_filters', filters);
		console.log('calendar_'+view.view.toLowerCase());
		append('#wrap', 'calendar_'+view.view.toLowerCase(), calendar);
		
		$(oldPage).after('<div id="calendar_template">' + settings.templates.date_picker + '</div>');
		$('#calendar_template').hide();
		
		// Hide old UI
		$(oldPage).hide();
		
	} // End page.calendar
} // End site.abi


  /*
if (url.match('abi.ndhs.org/?$')) {
	window.location = 'parentabi';
} else if (url.match('parentabi/?$') || url.match('Login')) {
	console.log('Page: login');
	
	$('body > table').hide();

	// Add page scripts
	embedScript(safari.extension.baseURI + 'page/login.js');
	embedCSS(safari.extension.baseURI + 'css/abi.css');
	
	// Remove ABI's CSS
	$('link[href*="cssABI"], link[href*="ABIDynamicMenus"]').remove();
	
	oldPage = $('table:first');
	
	var message = '';
	if (url.match('LoginHome')) {
		if ($('table table tbody tr [style*="#FFFF33"]')) {
			console.log("message found");
			settings.auto_login = false;
			message = $('table table tbody tr [style*="#FFFF33"]').text();
			console.log(message);
		}
	}
	$(oldPage).before(Mustache.to_html(settings.templates.login, {
			auto_login: settings.auto_login,
			email: settings.email,
			password: settings.password,
			message: message
		}, settings.templates.partials));
		

		
} else if (url.match('abi.ndhs.org')) {
	oldPage = $('table:first');
	$(oldPage).before(Mustache.to_html(settings.templates.abi_nav, {calendar: true}, settings.templates.partials));
	
	// Replace ABI's CSS
	$('link[href*="cssABI"], link[href*="ABIDynamicMenus"]').remove();
	embedCSS(safari.extension.baseURI + 'css/abi.css');
	
	if (url.match('MainMenu')) {
		embedScript(safari.extension.baseURI + 'lib/mustache.js'); //For use by the in-page scripts
		embedScript(safari.extension.baseURI + 'page/calendar.js');
		var months = ['January','February','March','April','May','June','July','August','September','October','November','December'];
		var weekdays = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'];
		var calendar = {};
		var today;
		
		if ($('#CalendarView :selected').text() == 'Day') {
				var date = new Date($('tbody tbody tbody tbody tbody .HeaderRowBold td:contains("/")').text())
				calendar['date'] = weekdays[date.getDay()]+', '+months[date.getMonth()]+' '+date.getDate()+', '+date.getFullYear();
				
				calendar['events'] = [];
				var calendarEvents = $('tbody tbody tbody tbody > tr.NormalRowEven table[style*="border-color"]');
				$(calendarEvents).each(function(i) {
					var style = $(calendarEvents).eq(i).attr('style');
					var eventColor = style.substring(style.indexOf('border-color')).match(/[0-9A-F]{6}/)[0];		
					
					var event = $('td[align="left"]', calendarEvents[i]);
					if (event.html().substring(0, event.html().indexOf('<span id='))) {
						var content = event.html().substring(0, event.html().indexOf('<span id=')).replace('&nbsp;','');
					} else {
						var content = event.html().replace('&nbsp;','');
					}
					
					if (eventColor == '0000FF') { // Blue = normal assignment
						if (event.text().match(/classwork:/i)) {
							type = 'Classwork';
						} else {
							type = 'Assignment';
						}
						
						var details = '';
						if ($('[id*="CalEventLong"]', event)[0]) {
							details = $('[id*="CalEventLong"]', event).html().replace('<br>','');  // Replaces only the first <br>. Dunno why, but that's what I want.
						}
						
						calendar.events[i] = {
							type:       type,
							start_time: content.match(/\d{1,2}:\d{1,2}\s[AP]M/g)[0],
							end_time:   content.match(/\d{1,2}:\d{1,2}\s[AP]M/g)[1],
							period:     content.match(/Pd \d{1,2}/)[0].match(/\d/)[0],
							body:       content.substring(content.indexOf(': ') + 2),
							details:    details
						}
					} else if (eventColor == '00FF00') { // Green = event
						console.log(event);
						if ( $('[alt*="Details"]', event).length > 0 ) {
							body = $(event).html().substring( $(event).html().indexOf('}">') + 3 );
							details = $(event).children('[id*="CalEventLong"]').html();
							details = details.substring(details.indexOf('<br>'+4));
						} else {
							body = event;
							details = '';
						}
						console.log(body, ' | | ', details);
					
						calendar.events[i] = {
							type: 'Class',
							body: event
						}
					} else if (eventColor == 'FF0000') { // Red = personal
						console.log(event);
						edit_function = $('img[alt*="Edit"]', $(event).parent()).attr('onclick') + '';
						console.log(edit_function,  edit_function.substring(  edit_function.indexOf('{')+1,  edit_function.indexOf('}')  ));
						calendar.events[i] = {
							type: 'Personal',
							body: content,
							edit_js: edit_function.substring(  edit_function.indexOf('{')+1,  edit_function.indexOf('}')  )
						}
					} else if (eventColor == 'FFFF00') { // Yellow = school
						calendar.events[i] = {
							type: 'School',
							body: content
						}
					} else if (eventColor == '669999') { // Grey = district
						calendar.events[i] = {
							type: 'District',
							body: content
						}
					} // end if (color)
				});
		} else { // If view type is month or week
			
			var calendarDays = $('tbody tbody tbody tbody > tr.NormalRowEven > td[align*="center"] > table > tbody'); // 5 tables and we're not even finished. Kill me.
			
			var monthName = $('tbody tbody tbody tbody > tr.HeaderRowBold > td[colspan*="6"]:not(:has(table))').text();
			var monthNum;
			switch (monthName) {
				case 'January':   monthNum = 1;  break;
				case 'February':  monthNum = 2;  break;
				case 'March':     monthNum = 3;  break;
				case 'April':     monthNum = 4;  break;
				case 'May':       monthNum = 5;  break;
				case 'June':      monthNum = 6;  break;
				case 'July':      monthNum = 7;  break;
				case 'August':    monthNum = 8;  break;
				case 'September': monthNum = 9;  break;
				case 'October':   monthNum = 10; break;
				case 'November':  monthNum = 11; break;
				case 'December':  monthNum = 12; break;
			}
			
			$(calendarDays).each(function(i) {
				var date;
				$('tr td b', calendarDays[i]).each(function(ii) { // Properly splits Saturday and Sunday (for dates, not for assignments)
					date = $('tr td b', calendarDays[i]).eq(ii).text();
					if ($('tr', calendarDays[i]).eq(0).attr('style') && $('tr', calendarDays[i]).eq(0).attr('style').match(/[0-9A-F]{6}/)[0]) {
						if (date <= 15) {
							month = monthNum + 1;
						} else {
							month = monthNum - 1;
						}
					} else {
						month = monthNum;
					}
					if (month == 0) {
						month = 12;
					} else if (month == 13) {
						month = 1;
					}
					date = month + '-' + date;
					calendar[date] = [];
				});
				var calendarEvents = $('span[id*="CalEventLong"]', calendarDays[i]);
	
				$(calendarEvents).each(function(j) {
					var style = $(calendarEvents).eq(j).closest('[style*="border-color"]').attr('style');
					var eventColor = style.substring(style.indexOf('border-color')).match(/[0-9A-F]{6}/)[0];
					
					//If the long description is empty, fall back to the short one.
					var event;
					if ($(calendarEvents).eq(j).html() != '') {
						event = $(calendarEvents).eq(j).html();
					} else {
						event = $(calendarEvents).eq(j).siblings('span[id*="CalEventShort"]').html();
					}
					
					if (eventColor == '0000FF') { // Blue = gradebook
						if (event.match(/classwork:/i)) {
							type = 'Classwork';
						} else {
							type = 'Assignment';
						}
						calendar[date][j] = {
							type: type,
							time:   event.match(/\d{1,2}:\d{1,2}\s[AP]M/)[0],
							period: parseInt( event.match(/Pd \d{1,2}/)[0].match(/\d/)[0] ),
							body:   event.substring(event.indexOf(': ') + 2)
						};
					} else if (eventColor == '00FF00') { // Green = class
						console.log(calendarEvents[j]);
						if ( $('[alt*="Details"]', calendarEvents[j]).length > 0 ) {
							body = event.substring( event.indexOf('}">') + 3 );
							details = $(calendarEvents).eq(j).children('[id*="CalEventLong"]').html();
							details = details.substring(details.indexOf('<br>'+4));
						} else {
							body = event;
							details = '';
						}
						console.log(body, details);
					
						calendar[date][j] = {
							type: 'Class',
							body: event
						}
					} else if (eventColor == 'FF0000') { // Red = personal
						calendar[date][j] = {
							type: 'Personal',
							body: event
						}
					} else if (eventColor == 'FFFF00') { // Yellow = school
						calendar[date][j] = {
							type: 'School',
							body: event
						}
					} else if (eventColor == '669999') { // Grey = district
						calendar[date][j] = {
							type: 'District',
							body: event
						}
					} // end if (color)
				}); // end each calendarEvents
			}); // end each calendarDays
		} // end if (day/week/month view)
		console.log(calendar);
		
		var messages = $('tbody tbody td[width="32%"] table:first tbody tbody .NormalRowEven td').html(); // I hate tables
		
		var event_types = [];
		$('#EventTypeContainer table table td').each(function(i) {
			event_types[i] = $('#EventTypeContainer table table td').eq(i).html();
		});
		
		var gradebooks = [];
		$('#GradebookContainer table td').each(function(i) {
			gradebooks[i] = $('#GradebookContainer table td').eq(i).html();
		});
		
		var classes = [];
		$('#SectionContainer table td').each(function(i) {
			classes[i] = $('#SectionContainer table td').eq(i).html();
		});
		
		$('span:contains("Change")').click(); // Trigger loading of calendar...
		$('#overDiv').attr('hidden', 'true'); // ...and then hide it
		
		var month = $('#overDiv font > font > b').eq(0).text();
		var today = new Date();
		
		var thisMonthNum = today.getMonth() + 1;
		switch (thisMonthNum) {
			case 'January':   monthNum = 1;  break;
			case 'February':  monthNum = 2;  break;
			case 'March':     monthNum = 3;  break;
			case 'April':     monthNum = 4;  break;
			case 'May':       monthNum = 5;  break;
			case 'June':      monthNum = 6;  break;
			case 'July':      monthNum = 7;  break;
			case 'August':    monthNum = 8;  break;
			case 'September': monthNum = 9;  break;
			case 'October':   monthNum = 10; break;
			case 'November':  monthNum = 11; break;
			case 'December':  monthNum = 12; break;
		}
				
		var today = new Date();
		var filters = {
			event_types: event_types,
			gradebooks: gradebooks,
			classes: classes,
			month: month,
			weeks: [] 
		}
		var calWeeks = $('#overDiv tr tr tr:has(td[onmouseover])')
		$(calWeeks).each(function(i) {
			filters.weeks[i] = { days: [] };
			var calDays = $('td', calWeeks[i]);
			$(calDays).each(function(j) {
				if ($(calDays).eq(j).text() != ' ')  var day = $(calDays).eq(j).text()				
				
				filters.weeks[i]['days'][j] = {
					day: day,
					selected: ($('b', calDays[j]).length > 0),
					today: (month.indexOf(months[today.getMonth()]) != -1 && day == today.getDate())
				}
			});
		});
		console.log(filters);
		

		
		
		
		// Finally, time to construct the UI!
		// Pertinent variables: calendar, messages, filters
		
		$(oldPage).before('<div id="wrap"></div>')
		$('#wrap')
			.append(Mustache.to_html( settings.templates.calendar_filters, filters, settings.templates.partials  ))
			.append(Mustache.to_html( settings.templates.calendar_day, calendar, settings.templates.partials  ));
			
		$(oldPage).after('<div id="calendar_template">' + settings.templates.date_picker + '</div>');
		$('#calendar_template').hide();
		
		//$(oldPage).hide();
	}
}
// */

$('body, html').removeClass('preload');

}




// Functions

function embedScript(url) {
	var s = document.createElement('script');
	s.src = safari.extension.baseURI + url;
	document.head.appendChild(s);
}

function embedCSS(url) {
	var s = document.createElement('link');
	s.href = safari.extension.baseURI + url;
	s.rel = 'stylesheet';
	document.head.appendChild(s);
}	

function append(selector, template, data) {
	$(selector).append( Mustache.to_html(settings.templates[template], data, settings.templates.partials) );
}
function prepend(selector, template, data) {
	$(selector).prepend( Mustache.to_html(settings.templates[template], data, settings.templates.partials) );
}
function before(selector, template, data) {
	$(selector).before( Mustache.to_html(settings.templates[template], data, settings.templates.partials) );
}

function getSite() {
	var url = (document.URL.indexOf('?') == -1) ? document.URL : document.URL.substring(0, document.URL.indexOf('?'));
	
	return {
		abi: ( url.match(/abi\./i) != null ),
		moodle: ( url.match(/\/moodle/i) != null ),
		naviance: ( url.match(/naviance/i) != null ),
		wiley: ( url.match(/wiley/i) != null ),
	}
}

function getPage() {
	var url = (document.URL.indexOf('?') == -1) ? document.URL : document.URL.substring(0, document.URL.indexOf('?'));
	
	return {
		root: ( url.match(/org\/?$/i) != null ),
		login: ( url.match(/parentabi\/?$/i) != null || url.match(/login/i) != null ),
		calendar: ( url.match(/MainMenu/i) != null )		
	}
}

function getCalendarView() {
	return {
		day: ( $('#CalendarView :selected:contains("Day")').length > 0 ),
		week: ( $('#CalendarView :selected:contains("Week")').length > 0 ),
		month: ( $('#CalendarView :selected:contains("Month")').length > 0 ),
		view: $('#CalendarView :selected:').text()
	}
}

function getEventType(event) {
	var style = $(event).closest('[style*="border-color"]').attr('style');
	color = style.substring(style.indexOf('border-color')).match(/[0-9A-F]{6}/)[0];
	
	if (color.indexOf('0000FF') != -1) { // Blue = gradebook
		if ( $(event).text().match(/classwork/i) ) {
			return 'Classwork';
		} else {
			return 'Assignment';
		}
	} else if (color.indexOf('00FF00') != -1) {
		return 'Class';
	} else if (color.indexOf('FF0000') != -1) {
		return 'Personal';
	} else if (color.indexOf('FFFF00') != -1) {
		return 'School';
	} else if (color.indexOf('669999') != -1) {
		return 'District';
	}
}

function getEventContent(event) {
	var content = $(event).html();
	content = content.replace(/&nbsp;/g, ' ')
		.replace(/<img\b[^>]*?Details[^>]*?>/i, '') // Remove details trigger
		.replace(/<span\b[^>]*?CalEventLong[^>]*?>(.*?)<\/span>/i, '') // Remove details
		.replace(/(Assignment Due: )|(Classwork: )/, ''); // Remove assignment/classwork prefixes
	
	return content;
}

function getEventBody(event) {
	var content = getEventContent(event);
	if (content.match(/Pd \d/)) {
		return content.match(/Pd \d- (.*)/i)[1]
	} else {
		return content;
	}
}

function getEventDetails(event) {
	var content = $(event).html();
	if (content.match(/<span id="CalEventLong[^>]*>(.*?)<\/span>/i)) {
		return content.match(/<span id="CalEventLong[^>]*>(.*?)<\/span>/i)[1].replace(/<br>/i,'');
	} else {
		return '';
	}
}

function getEventPeriod(event) {
	var content = getEventContent(event);
	return (content.match(/Pd (\d)/)) ? content.match(/Pd (\d)/)[1] : '';
}

function getEditJS(event) {
	var content = $(event).parent().html();
	if (content.match(/<img.*?Edit.*?onclick="([^"]*?)"/i)) {
		return content.match(/<img.*?Edit.*?onclick="([^"]*?)"/i)[1];
	} else {
		return '';
	}
}

function getFilter(selector) {
	var filter = [];
	$(selector).each(function(i) {
		filter[i] = $(selector).eq(i).html();
	});
	return filter;
}

function gatherFilters(date) {
	var filters = {
		month: date.strftime('%B %Y'),
		event_types: [],
		gradebooks: [],
		classes: [],
		weeks: [],
		view: view
	}
	
	filters.event_types = getFilter('#EventTypeContainer table table td');
	filters.gradebooks = getFilter('#GradebookContainer table td');
	filters.classes = getFilter('#SectionContainer table td');
	
	
			
	// Generate the template for the date picker
	var month = $('#overDiv font > font > b').eq(0).text();
	var calWeeks = $('#overDiv tr tr tr:has(td[onmouseover])')
	$(calWeeks).each(function(i) {
		filters.weeks[i] = { days: [] };
		var calDays = $('td', calWeeks[i]);
		
		$(calDays).each(function(j) {
			if ($(calDays).eq(j).text() != ' ') {
				var day = $(calDays).eq(j).text();
				var currentDate = new Date(day+' '+month);
				var today = (currentDate.toDateString() == new Date().toDateString());				
			} else {
				var day = '';
				var today = false;
			}
							
			filters.weeks[i]['days'][j] = {
				day: day,
				selected: ($('b', calDays[j]).length > 0),
				today: today
			}
		});
	});
	
	return filters;
}