var times = 0; var oldTimes = 0; // For reload()

function toggleFilter(filterID) {
	var filter = $('#' + filterID);
	if ( $(filter).hasClass('collapsed') ) {
		// Expand it
		$('a.collapse', filter).html('&#9660;').removeClass('collapse').addClass('expand');
		$(filter).removeClass('collapsed');
	} else {
		// Collapse it
		$('a.expand', filter).html('&#9652;').removeClass('expand').addClass('collapse');
		$(filter).addClass('collapsed');
	}
}

function prevMonth() {
	$('#overDiv a:contains("<Mon")').click();
	refreshCal();
}
function nextMonth() {
	$('#overDiv a:contains("Mon>")').click()
	refreshCal();
}
function refreshCal() {
	var months = ['January','February','March','April','May','June','July','August','September','October','November','December'];
	var today = new Date();
	var month = $('#overDiv font > font > b').eq(0).text();
	
	var calendar = {
		month: month,
		weeks: []
	}
	
	var calWeeks = $('#overDiv tr tr tr:has(td[onmouseover])')
	$(calWeeks).each(function(i) {
		calendar.weeks[i] = { days: [] };
		var calDays = $('td', calWeeks[i]);
		$(calDays).each(function(j) {
			if ($(calDays).eq(j).text() != ' ')  var day = $(calDays).eq(j).text()				
			
			calendar.weeks[i]['days'][j] = {
				day: day,
				selected: ($('b', calDays[j]).length > 0),
				today: (month.indexOf(months[today.getMonth()]) != -1 && day == today.getDate())
			}
		});
	});
	
	var template = $('#calendar_template').html();

	$('#date table').replaceWith( Mustache.to_html(template, calendar) );
}

function changeDay(day) {
	$('#overDiv tr tr tr td:contains("' + day + '")').click();
}


window.onload = function() {
	var items = $('.filter li')
	$(items).each(function(i) {
		if ( $('input:checked', items[i]).length > 0 ) {
			$(items[i]).addClass('checked');
		}
	});
	
	
	
	$('.filter li input').click(function() {
		var li = $(this).parent();
		console.log(li,  $(this).siblings('input:checked'),  $(this).parent() ); 
		if ( $('input:checked', li).length > 0 ) {
			$(li).addClass('checked');
		} else {
			$(li).removeClass('checked');
		}
		
		var filters = $('.NormalRow[style*="Transparent"]', '#EventTypeContainer, #GradebookContainer, #SectionContainer')
		var filter = $(li).text().replace(/\s$/,'');
		console.log('"'+filter+'"',   $('label:contains("' + filter + '")' , filters));
		$('label:contains("' + filter + '")' , filters).siblings('input').click(); 
		
		reload();
	});
	
	$('.show_details').click(function() {
		var details = $(this).siblings('.details');
		
		if ( $(details).hasClass('hidden') ) {
			$(details).removeClass('hidden');
			$(this).text('Hide Details');
		} else {
			$(details).addClass('hidden');
			$(this).text('Show Details');
		}
	});
	
	$('#view select').change(function() {
		$('#CalendarView').val( $(this).val() );
		reload();
	});
}

function reload() {
	times++;
	window.setTimeout(reloadEnd, 1500);
}

function reloadEnd() {
	oldTimes++;

	if (times == oldTimes) {
		$('tbody tbody tbody tbody tbody tbody span:contains("Refresh")').click();
	}
}